/*############################################################################
#                                                                            #
#             dICuTexas Instruments INA226vphCo               #
#                                                                            #
#@RpCmFFAtmelStudio 6.1(SP2)                                  #
#                                                                            #
#                                                  2014/02/17 Create by nPYO #
#                                                                            #
############################################################################*/
#ifndef __INA226_H__
#define __INA226_H__

#include <avr/io.h>

/* INA226 VgRl`imj						*/
#define INA226_SHUNT_R	5

/*														*/
/* CalibrationRegisterݒl`(XP[Op)		*/
/* Current = ShuntVoltage * CalibrationRegister			*/
/*														*/
#define INA226_CALIBRATION ( 2.5 * 2048 / INA226_SHUNT_R )

/* X[uAhX`									*/
/* A1,A0[q̓dɂ16ނ̃AhXݒ\	*/
#define INA226_TWI_ADDR				0x40	/* A1=GND ,A0=GND	*/
//#define INA226_TWI_ADDR			0x41	/* A1=GND ,A0=VS+	*/
//#define INA226_TWI_ADDR			0x42	/* A1=GND ,A0=SDA	*/
//#define INA226_TWI_ADDR			0x43	/* A1=GND ,A0=SCL	*/
//#define INA226_TWI_ADDR			0x44	/* A1=VS+ ,A0=GND	*/
//#define INA226_TWI_ADDR			0x45	/* A1=VS+ ,A0=VS+	*/
//#define INA226_TWI_ADDR			0x46	/* A1=VS+ ,A0=SDA	*/
//#define INA226_TWI_ADDR			0x47	/* A1=VS+ ,A0=SCL	*/
//#define INA226_TWI_ADDR			0x48	/* A1=SDA ,A0=GND	*/
//#define INA226_TWI_ADDR			0x49	/* A1=SDA ,A0=VS+	*/
//#define INA226_TWI_ADDR			0x4a	/* A1=SDA ,A0=SDA	*/
//#define INA226_TWI_ADDR			0x4b	/* A1=SDA ,A0=SCL	*/
//#define INA226_TWI_ADDR			0x4c	/* A1=SCL ,A0=GND	*/
//#define INA226_TWI_ADDR			0x4d	/* A1=SCL ,A0=VS+	*/
//#define INA226_TWI_ADDR			0x4e	/* A1=SCL ,A0=SDA	*/
//#define INA226_TWI_ADDR			0x4f	/* A1=SCL ,A0=SCL	*/

/* INA226 WX^ԍ`		*/
#define INA226_REG_CONFIGURATION	0x00	/* Zbg̏l 0x4127 ɐݒ肳Ă	*/
#define INA226_REG_SHUNT_VOLTAGE	0x01	/* dl = Ǐol(t16bit) ~ 2.5V	*/
#define INA226_REG_BUS_VOLTAGE		0x02	/* dl = Ǐol(16bit) ~ 1.25mV	*/
#define INA226_REG_POWER			0x03
#define INA226_REG_CURRENT			0x04
#define INA226_REG_CALIBRATION		0x05
#define INA226_REG_MASK_ENABLE		0x06
#define INA226_REG_ALERT_LIMIT		0x07
#define INA226_REG_DIE_ID			0xff

/* ϒlvZp̃Tv`	*/
#define INA226_AVG1		0
#define INA226_AVG4		1
#define INA226_AVG16	2
#define INA226_AVG64	3
#define INA226_AVG128	4
#define INA226_AVG256	5
#define INA226_AVG512	6
#define INA226_AVG1024	7

/* ֐vg^Cv錾			*/
void ina226_init( void );
void ina226_set_pointer( uint8_t reg );
void ina226_write( uint8_t reg ,uint16_t data );
uint16_t ina226_read( void );


uint32_t ina226_voltage( void );
uint32_t ina226_current( void );

#endif /* __INA226_H__ */